(deftemplate lego "template de definire a pieselor ca obiecte"
  (slot id)
  (slot material)
  (slot culoare)
  (slot grosime)
  (slot arie)
  (slot forma)
)

(deffacts baza
  (lego (id id1) (material lemn) (culoare alb) (grosime 8) (arie 20) (forma cerc))
  (lego (id id2) (material lemn) (culoare alb) (grosime 4) (arie 10) (forma patrat))
  (lego (id id3) (material lemn) (culoare alb) (grosime 5) (arie 30) (forma cerc))
  (lego (id id4) (material lemn) (culoare rosu) (grosime 3) (arie 20) (forma dreptunghi))
  (lego (id id5) (material lemn) (culoare rosu) (grosime 5) (arie 10) (forma patrat))
  (lego (id id6) (material lemn) (culoare galben) (grosime 3) (arie 10) (forma dreptunghi))
  (lego (id id7) (material plastic) (culoare galben) (grosime 5) (arie 8) (forma cerc))
  (lego (id id8) (material plastic) (culoare verde) (grosime 3) (arie 12) (forma patrat))
  (lego (id id9) (material plastic) (culoare verde) (grosime 3) (arie 15) (forma dreptunghi))
  (lego (id id10) (material plastic) (culoare alb) (grosime 4) (arie 20) (forma cerc))
  (lego (id id11) (material plastic) (culoare albastru) (grosime 4) (arie 25) (forma patrat))
  (lego (id id12) (material plastic) (culoare rosu) (grosime 5) (arie 20) (forma dreptunghi))
  (lego (id id13) (material plastic) (culoare verde) (grosime 5) (arie 30) (forma dreptunghi))
  (faza I)
)
; cele mai groase piese de aceeaşi arie

(defrule selectie7.1-obj "construiesc o grupa daca nu o am"
  (faza I)
  (lego (id ?id) (arie ?a)) 
  (not (grupa ?a $?))
  =>
  (assert (grupa ?a ?id))
)

(defrule selectie7.2-obj "adaug o piesa intr-o grupa"
  (faza I)
  (lego (id ?id) (arie ?a)) 
  ?s <- (grupa ?a $?rest)
  (test (not (member$ ?id $?rest)))
  =>
  (retract ?s)
  (assert (grupa ?a ?id $?rest))
)

(defrule tranzitieI-II
  (declare (salience -10))
  ?f <- (faza I)
  =>
  (retract ?f)
  (assert (faza II))
)

(defrule selectie7.3-obj "elimin din grupa piesele de grosime mai mica decat maximum"
  (faza II)
  ?s <- (grupa ?a ?id $?rest)
  (lego (arie ?a) (grosime ?g1))
  (lego (id ?id) (grosime ?g&:(> ?g1 ?g)))
  =>
  (retract ?s)
  (assert (grupa ?a $?rest))
)

(defrule tranzitieII-III
  (declare (salience -10))
  ?f <- (faza II)
  =>
  (retract ?f)
  (assert (faza III))
)

(defrule purje
  (faza III)
  ?s <- (grupa ?a ?id ? $?rest)
  =>
  (retract ?s)
  (assert (grupa ?a ?id))
)


  