(deftemplate lego "template de definire a pieselor ca obiecte"
  (slot id)
  (slot material)
  (slot culoare)
  (slot grosime)
  (slot arie)
  (slot forma)
)

(deffacts baza
  (lego (id id1) (material lemn) (culoare alb) (grosime 8) (arie 20) (forma cerc))
  (lego (id id2) (material lemn) (culoare alb) (grosime 4) (arie 10) (forma patrat))
  (lego (id id3) (material lemn) (culoare alb) (grosime 5) (arie 30) (forma cerc))
  (lego (id id4) (material lemn) (culoare rosu) (grosime 3) (arie 20) (forma dreptunghi))
  (lego (id id5) (material lemn) (culoare rosu) (grosime 5) (arie 10) (forma patrat))
  (lego (id id6) (material lemn) (culoare galben) (grosime 3) (arie 10) (forma dreptunghi))
  (lego (id id7) (material plastic) (culoare galben) (grosime 5) (arie 8) (forma cerc))
  (lego (id id8) (material plastic) (culoare verde) (grosime 3) (arie 12) (forma patrat))
  (lego (id id9) (material plastic) (culoare verde) (grosime 3) (arie 15) (forma dreptunghi))
  (lego (id id10) (material plastic) (culoare alb) (grosime 4) (arie 20) (forma cerc))
  (lego (id id11) (material plastic) (culoare albastru) (grosime 4) (arie 25) (forma patrat))
  (lego (id id12) (material plastic) (culoare rosu) (grosime 5) (arie 20) (forma dreptunghi))
  (lego (id id13) (material plastic) (culoare verde) (grosime 5) (arie 30) (forma dreptunghi))
)
; cele mai groase piese de aceeaşi arie

(defrule selectie8.1-obj "construiesc o grupa in care plasez numai cea mai groasa piesa"
  (lego (id ?id) (arie ?a) (grosime ?g))
  (not (lego (id ?id1&:(neq ?id1 ?id)) (arie ?a) (grosime ?g1&:(> ?g1 ?g))))
  (not (grupa ?a $?))
  =>
  (assert (grupa ?a ?id))
)
